clear all; close all; clc;
Ts = 0.2; %Inserir nos blocos zoh e na F.T. discreta do controlador
s = tf('s'); G = 1/(s*(s+0.3)); %G(s)
num_G = G.num{:}; %Colocar no numerador da F.T. da planta
den_G = G.den{:}; %Colocar no denominador da F.T. da planta
C = 15.877*(s+0.3)/(s+5.693); %C(s) com efeito do ZOH
C_d = c2d(C,Ts,'matched'); %Equiv. discreto 
num_C_d = C_d.num{:}; %Numerador da F.T. do controlador digital
den_C_d = C_d.den{:}; %Denominador da F.T. do controlador digital
t_run = 6; %Colocar no simulation stop time do SIMULINK
t_step = 1; %Colocar no parmetro step time do bloco step 
sim('controle_02'); %Executa o arquivo controle_02 do SIMULINK
subplot(121); plot(tout, r, 'k--', tout, y,'k'); %Grfico de sada
xlabel('Tempo (s)'); ylabel('Amplitide');
leg = legend('Referncia', 'Resposta');
td = 0:Ts:Ts*(length(u)-1); %Vetor de tempo discreto
subplot(122); stairs(td, u,'k'); %Grfico do sinal de controle
xlabel('nT_s (s)'); ylabel('u(nT_s)');