clear all; close all; clc;
Ts = 0.2; %Inserir nos blocos zoh e na F.T. discreta do controlador
s = tf('s'); G = 1/(s*(s+0.3)); %G(s)
num_G = G.num{:}; %Colocar no numerador da F.T. da planta
den_G = G.den{:}; %Colocar no denominador da F.T. da planta
C = 15.877*(s+0.3)/(s+5.693); %C(s) foi ajustado para considerar o efeito do ZOH
C_d = zpk(c2d(C,Ts,'matched'));
alpha = C_d.z{:}; %Captura o zero da F.T. discreta do controlador
beta = C_d.p{:}; %Captura o polo da F.T. discreta do controlador
Kc = C_d.k; %Captura o ganho da F.T. discreta do controlador
param = [alpha, beta, Kc];
t_run = 6; % colocar no simulation stop time do SIMULINK
t_step = 1; % colocar no parmetro step time do bloco step 
sim('controle_03'); %executa o arquivo controle_03 do SIMULINK
subplot(121); plot(tout, r, 'k--', tout, y,'k'); %Grfico de sada
leg = legend('Referncia', 'Resposta');
xlabel('Tempo (s)'); ylabel('Amplitide');
td = 0:Ts:Ts*(length(u)-1); %Vetor de tempo discreto
subplot(122); stairs(td, u,'k'); %Grfico do sinal de controle
xlabel('nT_s (s)'); ylabel('u(nT_s)');