clear all; close all; clc;
s = tf('s'); z = tf('z'); Ts = 1/4;
C = 4/((s+2)^2); wc = 6.866;
Cd1 = c2d(C,Ts,'Tustin'); Cd2 = c2d(C,Ts,'Prewarp',wc); 
w = logspace(log10(0.1),log10(10),50);
[M,F]=bode(C,w); [Md1,Fd1]=bode(Cd1,w);
[Md2,Fd2]=bode(Cd2,w);
figure(1); subplot(211); 
semilogx(w,20*log10(M(:)),'k'); hold on;
semilogx(w,20*log10(Md1(:)),'b*'); 
semilogx(w,20*log10(Md2(:)),'ro');
axis([0.1 10 -50 0]);
xlabel('Freq. (rad/s)'); ylabel('Amplitude (graus)');
subplot(212); semilogx(w,F(:),'k'); hold on;
semilogx(w,Fd1(:),'b*'); semilogx(w,Fd2(:),'ro'); 
axis([0.1 10 -200 0]);
xlabel('Freq. (rad/s)'); ylabel('Amplitude (graus)');