clear all; close all; clc;
rng shuffle
K_P = 3; T_I = 0.5; T_D = 0.3; N = 3; %Parmetros PID
t_run = 60; %Tempo de simulao (segundos)
t_step = 1; %Tempo de aplicao do degrau
veloc = 2;  %Velocidade de referncia (rad/s)
t_disturb_1 = 15; %Tempo de entrada do distrbio casado
t_disturb_2 = 35; %Tempo de sada do distrbio casado
disturb = 20; %Amplitude do pulso de distrbio
var_ruido = 0.01; %Varincia do rudo de medida
Ts = 0.02; %Perodo de Amoatragem
T_t = sqrt(T_I*T_D); %Tempo de atracamento do Anti-WIndup (1e10
sat = 30;
param = [Ts, K_P, T_I, T_D, T_t, N, sat];
item = 'a';
switch item
    case 'a'
        sim('SIM_Ex_04_04a.slx');  
    case 'b' 
        sim('SIM_Ex_04_04b.slx'); 
    case 'c' 
        sim('SIM_Ex_04_04c.slx'); 
    otherwise
        sim('SIM_Ex_04_04d.slx'); 
end

figure;subplot(121); plot(t_sim, r,'k', t_sim, y,'b','linewidth',1.0);
xlabel('Tempo (s)', 'Interpreter','latex','Fontsize',14);
ylabel('Amplitide', 'Interpreter','latex','Fontsize',14)
leg = legend('Refer\^{e}ncia','Sa\''{i}da');
set(leg,'Interpreter','latex','Fontsize',14);
n = 0:Ts:Ts*(length(u)-1); %vetor de tempo discreto
set(gca,'FontSize',12,'FontName', 'Times New Roman');

subplot(122); stairs(n, u,'k','linewidth',1.0); %grfico do sinal de controle
xlabel('$nT_s$ (s)','Interpreter','latex','Fontsize',14);
ylabel('Esfor\c{c}o de Controle (antes da satura\c{c}\~{a}o)','Interpreter','latex','Fontsize',14);
set(gca,'FontSize',12,'FontName', 'Times New Roman');
