clear all; close all; clc;
s = tf('s'); z = tf('z'); Ts_1 = 0.2; Ts_2 = 0.02;
Gs = 2/(s+2);
Gz_1 = c2d(Gs,Ts_1,'zoh'); 	Gw_1 = d2c(Gz_1,'tustin');
Gz_2 = c2d(Gs,Ts_2,'zoh'); 	Gw_2 = d2c(Gz_2,'tustin');
opts = bodeoptions('cstprefs'); 
opts.PhaseWrapping = 'on';
w = logspace(log10(0.1),log10(100),1e5);
bode(Gs,w,opts); hold on; bode(Gw_1,w,opts); bode(Gw_2,w,opts);
set(findall(gcf,'type','line'),'linewidth',1);
legend('$G(s)$','$G_D(z), T_s=0,2$','$G_D(z), T_s=0,02$',...
    'Interpreter','latex','Location','southwest');