clear all; close all; clc;
s = tf('s'); z = tf('z'); Ts = 0.1;
G = 1/(s*(s+1));
zeta = 0.7; wn = 5; 
Gd = zpk(c2d(G,Ts,'zoh'));
s1 = -zeta*wn+sqrt(-1)*wn*sqrt(1-zeta^2); z1 = exp(Ts*s1);
rlocus(Gd,'k'); hold on; axis([-4 2 -2 2]);
plot(real(z1),imag(z1),'sk');
set(findall(gcf,'type','line'),'linewidth',1.5); 
zgrid(zeta,wn,Ts); 
% Compensador por Avano de Fase
K = Gd.K; a = Gd.z{1}; b = Gd.p{1}(2);
alpha = b;
Phi = pi + angle(evalfr(Gd *(z-alpha),z1));
beta = real(z1)-imag(z1)/tan(Phi);
C_ = (z-alpha)/(z-beta);
Kc = 1/abs(evalfr(C_*Gd,z1));
Cd = Kc*C_; Cd.Ts = Ts;
F = (Cd*Gd);
figure(2); rlocus(F,0:0.01:1000,'k'); hold on;
set(findall(gcf,'type','line'),'linewidth',1.5); 
axis([-4 2 -2 2]); zgrid(zeta,wn,Ts); 
T = tf(minreal(feedback(F,1)));
plot(real(roots(T.den{:})), imag(roots(T.den{:})),'sk');
t_run = 6; sim('SIM_Ex_06_04.slx');
figure(3); subplot(121);
p = plot(tout, r,'K:',tout, y,'b'); 
set(p,'LineWidth',1.5);
set(gca,'FontName','Times New Roman','Fontsize',12);
title('Resposta ao Degrau','FontName',...
    'Times New Roman','Fontsize',14);
xlabel('$t\,\,(s)$','Interpreter','Latex','FontName',...
    'Times New Roman','Fontsize',14);
ylabel('$y(t)$','Interpreter','Latex','FontName',...
    'Times New Roman','Fontsize',14);
l = legend('Referncia','Resposta');
set(l,'Fontsize',14);
subplot(122);t_d = (0:length(u)-1)*Ts;
p2=stairs(t_d,u,'b');
set(gca,'FontName','Times New Roman','Fontsize',12);
set(p2,'LineWidth',1.5);
title('Ao de Controle','FontName',...
    'Times New Roman','Fontsize',14);
xlabel('$nT_s \,\,(s)$','Interpreter','Latex','FontName',...
    'Times New Roman','Fontsize',14);
ylabel('$u(nT_s)$','Interpreter','Latex','FontName',...
    'Times New Roman','Fontsize',14);