clear all; close all; clc;
s = tf('s'); z = tf('z'); Ts = 0.1;
G = 10/((s+1)*(s+2.5)); %Panta contínua
Gd = c2d(G,Ts,'zoh'); %Planta discreta com ZOH
Gd_MF = feedback(Gd,1);
figure(1); subplot(121); step(Gd_MF); 
set(findall(gcf,'type','line'),'linewidth',1);
subplot(122); rlocus(Gd,'k'); zgrid(0.421,-1);
set(findall(gcf,'type','line'),'linewidth',1);
Polos_MF = pole(Gd_MF);
hold on; plot(real(Polos_MF), imag(Polos_MF),'sk');
% Compensador por Atraso de Fase
ess = 0.02; beta = 0.999;
alpha = 1-((1-beta)*(1-ess))/(ess*evalfr(Gd,1));
Cd_temp = (z-alpha)/(z-beta);
CGd = Cd_temp*Gd; %Sistema compensado
figure(2); subplot(121); rlocus(CGd,0:0.0005:50,'k');
set(findall(gcf,'type','line'),'linewidth',1);
zgrid(0.421,-1); axis([0 1.5, -1.1 1.1])
K = 0.978; %Obtido usando a ferramenta Data cursor
t_run = 40; sim('SIM_Ex_06_05.slx');
subplot(122); p = plot(tout, r,'K:',tout, y_1,'b',tout, y_2,'r'); 
set(p,'LineWidth',1);
set(gca,'FontName','Times New Roman','Fontsize',12);
title('Resposta ao Degrau Unitario','FontName',...
    'Times New Roman','Fontsize',14);
xlabel('$t\,\,(s)$','Interpreter','Latex','FontName',...
    'Times New Roman','Fontsize',14);
ylabel('$y(t)$','Interpreter','Latex','FontName',...
    'Times New Roman','Fontsize',14);
l = legend('Referência','Sem Compensador','Com Compensador');
set(l,'FontName', 'Times New Roman','Fontsize',14);
