clear all; close all; clc;
Mp = 0.046; zeta = 0.7; %zeta = sqrt(log(Mp)^2 / (pi^2 + log(Mp)^2));
wn = 2.5; wd = wn*sqrt(1-zeta^2); tp = pi/wd; Td = 2*pi/wd;
s = tf('s'); z = tf('z'); Ts = 0.25;
G = 2/((s+2)*(s+3));
G_D = c2d(G,Ts,'zoh'); G_zer = zero(G_D); G_pol = pole(G_D);
s1 = -zeta*wn+j*wn*sqrt(1-zeta^2); z1 = exp(Ts*s1);
c2 = G_pol(1);
% Condio de Fase
P=-pi-angle(z1-G_zer)+angle(z1)+angle(z1-1)+angle(z1-G_pol(2));
c1 = -imag(z1)/tan(P)+real(z1);
% Condio de Mdulo
C_D_temp = ((z-c1)*(z-c2))/(z*(z-1)); C_D_temp.Ts = Ts;
K = 1/abs(evalfr((G_D*C_D_temp),z1));
C_D = K*C_D_temp;
F = minreal(C_D*G_D);
figure(1);rlocus(C_D_temp*G_D,'k');zgrid(zeta,wn,Ts); 
axis([-2 2 -2 2]); hold on;
set(findall(gcf,'type','line'),'linewidth',1.5); 
G_MF = feedback(F,1); G_MF_pol = pole(G_MF);
plot(real(G_MF_pol), imag(G_MF_pol),'sk')

%Obter os valores equivalentes de K_P, T_I e T_D
K_P = (K*(c1 + c2 - 3*c1*c2 + 1))/2;
T_I = -(Ts*(c1 + c2 - 3*c1*c2 + 1))/(2*(c1 + c2 - c1*c2 - 1));
T_D = (2*Ts*c1*c2)/(c1 + c2 - 3*c1*c2 + 1);
% Forma usando o toolbox de controle para achar Kp, Ti e Td
%G_D_PID = pid(C_D,'Iformula','Trapezoidal','Dformula','BackwardEuler')
%K_P = G_D_PID.Kp;
%T_I = K_P/G_D_PID.Ki;
%T_D = G_D_PID.Kd/K_P;
t_run = 6; sim('SIM_Ex_06_06.slx');
figure(2); subplot(121);
p = plot(tout, r,'K:',tout, y,'b'); 
set(p,'LineWidth',2);
set(p,'LineWidth',2,'MarkerSize',4);
set(gca,'FontName','Times New Roman','Fontsize',12);
title('Resposta ao Degrau Unitario','FontName',...
    'Times New Roman','Fontsize',14);
xlabel('$t\,\,(s)$','Interpreter','Latex','FontName',...
    'Times New Roman','Fontsize',14);
ylabel('$y(t)$','Interpreter','Latex','FontName',...
    'Times New Roman','Fontsize',14);
l = legend('Referncia','Resposta com PID');
set(l,'FontName', 'Times New Roman','Fontsize',14);

subplot(122);t_d = (0:length(u)-1)*Ts;
p2=stairs(t_d,u,'b');
set(gca,'FontName','Times New Roman','Fontsize',12);
set(p2,'LineWidth',1.5);
title('Ao de Controle','FontName',...
    'Times New Roman','Fontsize',14);
xlabel('$nT_s \,\,(s)$','Interpreter','Latex','FontName',...
    'Times New Roman','Fontsize',14);
ylabel('$u(nT_s)$','Interpreter','Latex','FontName',...
    'Times New Roman','Fontsize',14);

