clear all; close all; clc;
s = tf('s'); z = tf('z');  Ts = 0.2;
G = 0.1/((s+1));
Gd = c2d(G,Ts,'zoh'); %Sistema no plano-z
Gw = d2c(Gd,'Tustin');%Sistema no plano-w (em s, leia-se w)
w = logspace(log10(0.1),log10(100),1e5);
opts = bodeoptions('cstprefs'); 
opts.PhaseWrapping = 'on';
bode(Gw,w,opts);
set(findall(gcf,'type','line'),'linewidth',1);
nu_G = 2;
theta_G = angle(evalfr(Gw,j*nu_G))*180/pi; %Em graus
phi_C = (60-(180+theta_G)); %Em graus
T_i = tan(phi_C*pi/180 +pi/2)/nu_G; %Conta feita em rad
Cw_ = (T_i*s+1)/s;
CGw_ = Cw_*Gw;
figure; bode(Gw,w,opts);hold on; bode(CGw_,w);
set(findall(gcf,'type','line'),'linewidth',1);
K = 1/abs(evalfr(CGw_,j*nu_G)); %Ajuste para ter ganho unitário em nu_G
Cw = K*Cw_;
Cd = c2d(Cw,Ts,'Tustin'); %Conversão para o plano-z
figure; margin(Cw*Gw); %Bode com margens de fase e de ganho em w
set(findall(gcf,'type','line'),'linewidth',1);
figure; margin(Cd*Gd); %Bode com margens de fase e de ganho em z
set(findall(gcf,'type','line'),'linewidth',1);
Cd_zpk = zpk(Cd); Kc = Cd_zpk.k; alpha = Cd_zpk.z{1}(1); beta = Cd_zpk.p{1}(1);
t_run = 6; sim('SIM_Ex_06_04.slx'); %Mesmo arquivo de simulação do Ex. 6.4
figure; subplot(121); p = plot(tout, r,'K:',tout, y,'b'); 
set(p,'LineWidth',2,'MarkerSize',4);
set(gca,'FontName','Times New Roman','Fontsize',12);
title('Resposta ao Degrau Unitario','FontName',...
    'Times New Roman','Fontsize',14);
xlabel('$t\,\,(s)$','Interpreter','Latex','FontName',...
    'Times New Roman','Fontsize',14);
ylabel('$y(t)$','Interpreter','Latex','FontName',...
    'Times New Roman','Fontsize',14);
l = legend('Referência','Resposta');
set(l,'FontName', 'Times New Roman','Fontsize',14);

subplot(122);t_d = (0:length(u)-1)*Ts; p2=stairs(t_d,u,'b');
set(gca,'FontName','Times New Roman','Fontsize',12);
set(p2,'LineWidth',1.5);
title('Ação de Controle','FontName',...
    'Times New Roman','Fontsize',14);
xlabel('$nT_s \,\,(s)$','Interpreter','Latex','FontName',...
    'Times New Roman','Fontsize',14);
ylabel('$u(nT_s)$','Interpreter','Latex','FontName',...
    'Times New Roman','Fontsize',14);