clear all; close all; clc;
s = tf('s'); z = tf('z'); Ts = 0.5; 
G = 1/(s*(7*s +1)); Gd = c2d(G,Ts,'zoh');
zeta = sqrt(2)/2; wn = 1;
s1 = -zeta*wn+sqrt(-1)*wn*sqrt(1-zeta^2); z1 = exp(Ts*s1);
den_G_MF_coefs = poly([z1; z1']);
ze = zero(Gd);
% Soluco do sistema para achar b1, b2 e b3 (A*b = d)
A = [ze^(-1) ze^(-2) ze^(-3); 1 1 1; 1 2 3]; d = [0;0;0];
d(2) = sum(den_G_MF_coefs); %b1+b2+b3...
d(3) = 2*d(2)-(-den_G_MF_coefs(2)-2*den_G_MF_coefs(3));
b = A\d; % Resolve A*b=d
Gd_MF = (b(1)*z^2+b(2)*z+b(3))/(z*(z-z1)*(z-z1')); Gd_MF.Ts = Ts;
Cd = minreal((1/Gd)*Gd_MF/(1-Gd_MF));
Cd_zpk = zpk(Cd); 
Kc_1 = Cd_zpk.k; alpha_1 = Cd_zpk.z{1}(1); beta_1 = Cd_zpk.p{1}(1);
Kc_2 = 1;        alpha_2 = Cd_zpk.z{1}(2); beta_2 = Cd_zpk.p{1}(2);
t_run = 10; sim('SIM_Ex_07_01_a_07_05.slx');
subplot(211); plot(t, y_1); hold on; 
grid;
n = 0:Ts:Ts*(length(y_2)-1); stairs(n, y_2,'r-*','linewidth',1.5); 
title('Resposta ao Degrau Unitrio');
xlabel('$t\,\,(s)$', 'Interpreter', 'Latex');
ylabel('$y(t)$', 'Interpreter', 'Latex');
set(findall(gcf,'type','line'),'linewidth',1.5); 
subplot(212); stairs(n, u,'linewidth',1.5); 
grid;
title('Ao de Controle');
xlabel('$nT_s \,\,(s)$', 'Interpreter', 'Latex');
ylabel('$u(nT_s)$', 'Interpreter', 'Latex');
figure(2); subplot(211);
grid;
plot(t,t,'k--'); hold on;
plot(t, y_3);
n = 0:Ts:Ts*(length(y_4)-1);
set(findall(gcf,'type','line'),'linewidth',1.5); 
stairs(n, y_4,'r-*','linewidth',1.5);  
grid;
title('Resposta  Rampa Unitria');
xlabel('$t\,\,(s)$', 'Interpreter', 'Latex');
ylabel('$y(t)$', 'Interpreter', 'Latex');
subplot(212); stairs(n, u1,'linewidth',1.5); 
grid;
title('Ao de Controle');
xlabel('$nT_s \,\,(s)$', 'Interpreter', 'Latex');
ylabel('$u(nT_s)$', 'Interpreter', 'Latex');