clear all; clc; close all;
s = tf('s'); z = tf('z'); Ts = 0.5;
G = 1/((s+1)*(s+2));
q=1; k=0;
Gd = c2d(G,Ts,'zoh'); %Discretiza a planta
Cd = (1/Gd)*(z^(-k-1)*(1-exp(-Ts/q))/...
    (1-exp(-Ts/q)*z^-1 - (1-exp(-Ts/q))*z^(-k-1)));
Cd = minreal(Cd); %Simplifica a F.T. do controlador
Cd_zpk = zpk(Cd);
Kc_1 = Cd_zpk.k; alpha_1 = Cd_zpk.z{1}(1); beta_1 = Cd_zpk.p{1}(1);
Kc_2 = 1;        alpha_2 = Cd_zpk.z{1}(2); beta_2 = Cd_zpk.p{1}(2);
t_run = 10; sim('SIM_Ex_07_01_a_07_05.slx');
subplot(211); plot(t, y_1, 'LineWidth',1.5); hold on;
n = 0:Ts:Ts*(length(y_2)-1); 
stairs(n, y_2,'-*','LineWidth',1.5);
title('Resposta ao Degrau Unitrio');
xlabel('$t\,\,(s)$', 'Interpreter', 'Latex');
ylabel('$y(t)$', 'Interpreter', 'Latex');
legend('$y(t)$','$y(nT_s)$','Interpreter','Latex','Location','southeast')
subplot(212); stairs(n, u, 'LineWidth',1.5);
title('Ao de Controle');
xlabel('$nT_s \,\,(s)$', 'Interpreter', 'Latex');
ylabel('$u(nT_s)$', 'Interpreter', 'Latex');