clear all; close all; clc;
s = tf('s'); z = tf('z'); Ts = 0.2;
G = 1/((s+0.3)*(s+0.7));
Gd = c2d(G,Ts,'zoh'); %Discretiza a planta
k = 0; q = 0.5;
G_MF  = minreal((1-exp(-Ts/q))/(z-exp(-Ts/q)));
ze = zero(Gd);
K = evalfr(minreal(1/(G_MF*(z-ze)/z)),1);
G_MF_mod = K*G_MF*(z-ze)/z;
Cd = minreal((1/Gd)*G_MF_mod/(1-G_MF_mod));
Cd_zpk = zpk(Cd);
Kc_1 = Cd_zpk.k; alpha_1 = Cd_zpk.z{1}(1); beta_1 = Cd_zpk.p{1}(1);
Kc_2 = 1;        alpha_2 = Cd_zpk.z{1}(2); beta_2 = Cd_zpk.p{1}(2);
t_run = 4; sim('SIM_Ex_07_01_a_07_05.slx');
subplot(211); plot(t, y_1); hold on;
set(findall(gcf,'type','line'),'linewidth',1.5); 
n = 0:Ts:Ts*(length(y_2)-1); stairs(n, y_2,'r-*','linewidth',1.5); 
title('Resposta ao Degrau Unitrio');
xlabel('$t\,\,(s)$', 'Interpreter', 'Latex');
ylabel('$y(t)$', 'Interpreter', 'Latex');
subplot(212); stairs(n, u,'linewidth',1.5); 
title('Ao de Controle');
xlabel('$nT_s \,\,(s)$', 'Interpreter', 'Latex');
ylabel('$u(nT_s)$', 'Interpreter', 'Latex');