clear all; clc; close all;
s = tf('s'); z = tf('z'); Ts = 1;
G_sem_delay = 1/(1+10*s);
G = G_sem_delay * exp(-2*s);
q=5; k=2;
Gd_sem_delay = c2d(G_sem_delay,Ts,'zoh');
Gd = Gd_sem_delay * z^(-2);
Cd = (1/Gd)*(z^(-k-1)*(1-exp(-Ts/q))/(1-exp(-Ts/q)*z^-1 - ...
    (1-exp(-Ts/q))*z^(-k-1)));
Cd = minreal(Cd); %Simplifica a F.T. do controlador
num_Cd = Cd.num{:}; den_Cd = Cd.den{:};
beta_0 = num_Cd(1); beta_1 = num_Cd(2);
alpha_1 = den_Cd(2); alpha_3 = den_Cd(4); %alpha(2) = den_Cd(3)  ~ 0
Cd_zpk = zpk(Cd);
t_run = 40; sim('SIM_Ex_07_06.slx');
subplot(211); plot(t, y_1); hold on; 
n = 0:Ts:Ts*(length(y_2)-1); stairs(n, y_2,'r-*','linewidth',1.5); 
title('Resposta ao Degrau Unitrio');
xlabel('$t\,\,(s)$', 'Interpreter', 'Latex');
ylabel('$y(t)$', 'Interpreter', 'Latex');
set(findall(gcf,'type','line'),'linewidth',1.5); 
subplot(212); stairs(n, u,'linewidth',1.5); 
title('Ao de Controle');
xlabel('$nT_s \,\,(s)$', 'Interpreter', 'Latex');
ylabel('$u(nT_s)$', 'Interpreter', 'Latex');