clear all; clc; close all;
fs=20; Ts=1/fs;
K_G = 0.6; %Numerador da F. T.
A = [-0.7 0; 1 0]; B = [0.6; 0]; C = [0 1]; D = 0;
[Phi,Gamma] =  c2d(A,B,Ts);
wn = 5.0; zeta = 0.7;
s1 = wn*(-zeta+sqrt(-1)*sqrt(1-zeta^2));
p_c = exp([s1; s1']*Ts); %Polos do sist. de controle em MF
wn2 = 10.0; zeta2 = 0.707;
s2 = wn2*(-zeta2+sqrt(-1)*sqrt(1-zeta2^2));
p_o = exp([s2; s2']*Ts); %Polos do sist. observador completo
p_or = real(p_o(1)); %Polos do sist. observador de ord. reduzida
K = place(Phi,Gamma,p_c); % Projeto do Controlador
F = inv(C*inv(eye(2) - Phi + Gamma * K) * Gamma); % Pré-filtro
item = 'a'; %seleciona o item
switch(item)
    case 'a' %Realimentação de estados medidos
        sim('SIM_Ex_08_10a.slx');
    case 'b' %Realim. de estados estimados (obs . preditor)
        L = place( Phi',C' ,p_o )'; % Projeto do obs . preditor
        sim('SIM_Ex_08_10b.slx');
    case 'c' %Realimentação de estados estimados (obs. valor atual)
        Lc = place(Phi', (C*Phi)',p_o)';
        sim('SIM_Ex_08_10c.slx');
    otherwise
        error('item precisa ser ''a'', ''b'' ou ''c'' ');
end
figure(5);
x_1 = x_out(:,1); x_2 = x_out(:,2);
t_d = (0:length(x_1)-1)*Ts;
subplot(2,1,1);plot(t,r,'b',t,y,'r');
xlabel('$t$','Interpreter','latex'); 
ylabel('Amplitude','Interpreter','latex')
leg = legend('Setpoint','Sa\''{i}da');
set(leg,'Interpreter','latex','Location','best');
set(findall(gcf,'type','line'),'linewidth',1.5); 
subplot(2,1,2);stairs(t_d,x_1,'b','linewidth',1.5);
hold on; stairs(t_d,x_2,'r','linewidth',1.5);
xlabel('$n T_s$','Interpreter','latex');  
ylabel('Amplitude','Interpreter','latex')
leg = legend('$x_1(n T_s)$','$x_2(n T_s)$');
set(leg,'Interpreter','latex','Location','best');
figure(6); stairs(t_d, u,'linewidth',1.5);
xlabel('$n T_s$','Interpreter','latex'); 
ylabel('$u(n T_s)$','Interpreter','latex');