clear all; clc; close all;
fs=20; Ts=1/fs;
A = [-11 -10; 1 0]; B = [1; 0]; C = [0 1];
%OBS: no bloco State-Space foi feito C=eye(2) para obter na saída todos os 
%estados para a realimentação. Para obter y, tomou-se a 2a saída
[Phi,Gamma] =  c2d(A,B,Ts);
Phi_ = [Phi zeros(2,1); -C 1]; Gamma_ = [Gamma; 0]; 
wn = 5.71; zeta = 0.7;
s1 = wn*(-zeta+sqrt(-1)*sqrt(1-zeta^2));
p_c = exp([s1; s1']*Ts); %Polos do sist. de controle em MF
p_c = [p_c; 0.2]; %O terceiro polo foi inserido em z = 0.2
K_ = place(Phi_,Gamma_,p_c); % Projeto do Controlador
K = K_(1:2); Ki = -K_(3);
sim('SIM_Ex_08_11.slx');
x_1 = x_out(:,1); x_2 = x_out(:,2);
t_d = (0:length(x_1)-1)*Ts;
figure(5); subplot(2,1,1);plot(t,r,'b',t,y,'r');
xlabel('$t$','Interpreter','latex'); 
ylabel('Amplitude','Interpreter','latex')
leg = legend('Setpoint','Sa\''{i}da');
set(leg,'Interpreter','latex','Location','best');
set(findall(gcf,'type','line'),'linewidth',1.5); 
subplot(2,1,2);stairs(t_d,x_1,'b','linewidth',1.5);
hold on; stairs(t_d,x_2,'r','linewidth',1.5);
xlabel('$n T_s$','Interpreter','latex');  
ylabel('Amplitude','Interpreter','latex')
leg = legend('$x_1(n T_s)$','$x_2(n T_s)$');
set(leg,'Interpreter','latex','Location','best');
figure(6); stairs(t_d, u,'linewidth',1.5);
xlabel('$n T_s$','Interpreter','latex'); 
ylabel('$u(n T_s)$','Interpreter','latex');