clear all; clc; close all;
fs=10; Ts=1/fs;
A = [-0.7 0; 1 0]; B = [1; 0]; C = [0 1]; D = 0;
[Phi,Gamma] =  c2d(A,B,Ts);
Phi_ = [Phi zeros(2,1); -C 1]; Gamma_ = [Gamma; 0]; %Sist. com Int.
%Polos do sist. de controle em MF
wn = 3.5; zeta = 0.7; s1 = wn*(-zeta+sqrt(-1)*sqrt(1-zeta^2));
p_c = exp([s1; s1'; -2.5]*Ts); %Polos do sist. de controle em MF com int
wn2 = 10.0; xsi2 = 0.7; s2 = wn2*(-xsi2+sqrt(-1)*sqrt(1-xsi2^2));
wn3 = 7.0; xsi3 = 0.99; s3 = wn3*(-xsi3+sqrt(-1)*sqrt(1-xsi3^2));
p_o = exp([s2; s2';s3; s3']*Ts); %Polos do sist. observador completo
K = place(Phi_,Gamma_,p_c); % Projeto do Controlador
% Observador aumentado para rejeitar distúrbio
w0 = 15*2*pi/60; %RPM to rad/s
%x_aum = [x1; x2; w ; \dot w]
A_w = [0 1; -w0^2 0]; C_w = [1 0];
A_aum = [A B*C_w; zeros(2) A_w];
B_aum = [B; zeros(2,1)];
[Phi_aum,Gamma_aum] =c2d(A_aum,B_aum,Ts);
C_aum = [C , zeros(1,2)];
L = place(Phi_aum',C_aum',p_o)';
sim('SIM_Ex_08_12.slx')
figure(1);
x_1 = x_out(:,1); x_2 = x_out(:,2);
t_d = (0:length(x_1)-1)*Ts;
subplot(2,1,1);plot(t,r,'b',t,y,'r');
xlabel('$t$','Interpreter','latex');
ylabel('Amplitude','Interpreter','latex')
leg = legend('Setpoint','Sa\''{i}da');
set(leg,'Interpreter','latex','Location','best');
set(findall(gcf,'type','line'),'linewidth',1.5); 
subplot(2,1,2); stairs(t_d,x_1,'b','linewidth',1.5);
hold on; stairs(t_d,x_2,'r','linewidth',1.5);
xlabel('$n T_s$','Interpreter','latex');
ylabel('Amplitude','Interpreter','latex')
leg = legend('$x_1(n T_s)$','$x_2(n T_s)$');
set(leg,'Interpreter','latex','Location','best');
figure(2); stairs(t_d, u,'linewidth',1.5);
xlabel('$n T_s$','Interpreter','latex');
ylabel('$u(n T_s)$','Interpreter','latex');
figure(3); plot(t,w_in); hold on; 
set(findall(gcf,'type','line'),'linewidth',1.5); 
stairs(t_d,w_out,'linewidth',1.5);
xlabel('$n T_s$','Interpreter','latex');
ylabel('Disturb.','Interpreter','latex');
leg = legend('$w(t)$','$\hat w[n]$');
set(leg,'Interpreter','latex','Location','best');
