clear all; clc; close all;
fs=100; Ts=1/fs;
load('Modelo_Roda_Reacao');
[Phi,Gamma] =  c2d(A,B,Ts);
C = [1 0 0 0; 0 1 0 0];
%% Observador
% Preditor
p_o = [0.3;0.31;0.32;0.33];
L = place(Phi',C',p_o)';
% Observador valor atual
L_va = place(Phi',(C*Phi)',p_o)';
%% Alocação de polos
% Redução do modelo (retirar o estado TH2)
Phi_red = [Phi(1,1) Phi(1,3:4); Phi(3:4,1) Phi(3:4,3:4)];
Gamma_red = [Gamma(1); Gamma(3:4)];
% Imposição de polos
p_c = [0.83;0.82;0.9];
K = place(Phi_red,Gamma_red,p_c);
%% Simulação
t_run = 0.8;
x0 = [10*pi/180; 0; 0; 0];
sim('SIM_Ex_08_13a.slx');
x_pred = x; u_pred = u; t_pred = t;
t_d_pred = (0:length(u_pred)-1)*Ts;
sim('SIM_Ex_08_13b.slx');
x_atual = x; u_atual = u; t_atual = t;
t_d_atual = (0:length(u_atual)-1)*Ts;
figure(1); 
subplot(3,1,1); plot(t_pred,x_pred(:,1),t_atual,x_atual(:,1)); hold on
ylabel('$\theta_1$ [rad]', 'Interpreter','latex','Fontsize',14);
xlabel('$t$','Interpreter','latex','Fontsize',14);
leg = legend('$\theta_{1}^{\rm pred}$','$\theta_{1}^{\rm atual}$','Orientation','horizontal');
set(leg,'Interpreter','latex','Fontsize',14);

set(gca,'FontSize',12,'FontName', 'Times New Roman');
subplot(3,1,2); plot(t_pred,x_pred(:,3:4),t_atual,x_atual(:,3:4));
ylabel('$\omega$ [rad/s]', 'Interpreter','latex','Fontsize',14);
set(gca,'FontSize',12,'FontName', 'Times New Roman');
set(findall(gcf,'type','line'),'linewidth',1.5);
leg = legend('$\omega_1^{\rm pred}$','$\omega_2^{\rm pred}$',...
    '$\omega_1^{\rm atual}$','$\omega_2^{\rm atual}$','Orientation','horizontal');
set(leg,'Interpreter','latex','Fontsize',14);
xlabel('$t$','Interpreter','latex','Fontsize',14);
subplot(3,1,3); stairs(t_d_pred, u_pred,'linewidth',1.5);
hold on; stairs(t_d_atual, u_atual,'linewidth',1.5);
set(gca,'FontSize',12,'FontName', 'Times New Roman');
xlabel('$n T_s$','Interpreter','latex','Fontsize',14);
ylabel('$u(n T_s)$','Interpreter','latex','Fontsize',14);
leg = legend('$u^{\rm pred}$','$u^{\rm atual}$','Orientation','horizontal');
set(leg,'Interpreter','latex','Fontsize',14);
