clear all; clc; close all;
fs=100; Ts=1/fs;
load('Modelo_Furuta.mat') %Carrega modelo em tempo contnuo (A, B, C, D)
[Phi,Gamma] =  c2d(A,B,Ts);
x0 = [0 5*pi/180 0 0]; % Condies iniciais
item = 'a'; %Escolher 'a' ou 'b'
switch(item)
    case 'a' % Item a
        p_c1 = exp(Ts*[-3 -3.5 -11 -10]);
        K = place(Phi, Gamma, p_c1);
        t_run = 7;
        sim('SIM_Ex_08_14a.slx');
        figure(1); t_d = (0:length(u)-1)*Ts;
        subplot(2,1,1); plot(t,x);
        set(gca,'FontSize',12,'FontName', 'Times New Roman');
        set(findall(gcf,'type','line'),'linewidth',1.5);
        leg = legend('$\theta_0$','$\theta_1$',...
            '$\omega_0$','$\omega_1$');
        set(leg,'Interpreter','latex','Fontsize',14);
        xlabel('$t$','Interpreter','latex','Fontsize',14);
        ylabel({'\,\,\,\,\,\,\, Estados';'$\theta$ [rad], $\omega$ [rad/s]'},...
            'Interpreter','latex','Fontsize',14);
        subplot(2,1,2),stairs(t_d, u,'linewidth',1.5);
        set(gca,'FontSize',12,'FontName', 'Times New Roman');
        xlabel('$n T_s$','Interpreter','latex','Fontsize',14);
        ylabel('$u(n T_s)$','Interpreter','latex','Fontsize',14);
    otherwise
        %Item b
        C = [1 0 0 0]; %Nesse caso, a sada  a posio do brao
        Phi_ = [Phi zeros(4,1); -C 1]; Gamma_ = [Gamma; 0]; %Sist. aumentado com Int.
        p_c2 = exp(Ts*[-3 -3.5 -11 -10 -0.8]);
        K_ = place(Phi_, Gamma_, p_c2);
        K = K_(1:4); Ki = - K_(5);
        t_run = 40;
        sim('SIM_Ex_08_14b.slx');
        figure(2); t_d = (0:length(u)-1)*Ts;
        subplot(2,1,1);plot(t,r,'k--'); hold; plot(t,x);
        set(gca,'FontSize',12,'FontName', 'Times New Roman');
        set(findall(gcf,'type','line'),'linewidth',1.5);
        leg = legend('$\theta_0^{\rm ref}$','$\theta_0$','$\theta_1$',...
            '$\omega_0$','$\omega_1$');
        set(leg,'Interpreter','latex','Fontsize',14);
        xlabel('$t$','Interpreter','latex');
        ylabel({'Refer\^{e}ncia e Estados';'$\theta$ [rad], $\omega$ [rad/s]'},...
            'Interpreter','latex','Fontsize',14);
        subplot(2,1,2),stairs(t_d, u,'linewidth',1.5);
        set(gca,'FontSize',12,'FontName', 'Times New Roman');
        xlabel('$n T_s$','Interpreter','latex','Fontsize',14);
        ylabel('$u(n T_s)$','Interpreter','latex','Fontsize',14);
end