clear all; clc; close all;
fs=2; Ts=1/fs;
K_G = 0.6; %Numerador da F. T.
A = [-0.01046 0         0.0306  0;
     0        -0.01046  0       0.0253;
     0        0         -0.0306 0;
     0        0         0       -0.0253];
B = [0.03961   0; 0 0.04103; 0 0.02971; 0.03112 0];
C = [1 0 0 0; 0 1 0 0];
[Phi,Gamma] =  c2d(A,B,Ts);
Phi_ = [Phi zeros(4,2); -C eye(2)]; Gamma_ = [Gamma; zeros(2)]; 
K = dlqr(Phi_,Gamma_,diag([5 5 1e-3 1e-3 1e-1 1e-1]),10*eye(2)); % Projeto do Controlador
sim('SIM_Ex_09_02.slx');
close all; figure(1);
t_d = (0:length(u)-1)*Ts;
subplot(2,1,1);
plot(t,r(:,1),'b--', t,r(:,2),'r--'); hold on; plot(t,x);
set(findall(gcf,'type','line'),'linewidth',1.0); 
ylabel({'Varia\c{c}\~{a}o de $h$';'em torno de $\bar h$'},'Interpreter','latex');
xlabel('$t$','Interpreter','latex'); 
leg = legend('$h_1^{\rm ref}$','$h_2^{\rm ref}$','$h_1$','$h_2$','$h_3$','$h_4$');
set(leg,'Interpreter','latex','Location','best');
subplot(2,1,2);stairs(t_d,u(:,1),'b','linewidth',1.0);
hold on; stairs(t_d,u(:,2),'r','linewidth',1.0);
xlabel('$n T_s$','Interpreter','latex');  
ylabel({'Varia\c{c}\~{a}o de $v$';'em torno de $\bar v$'},'Interpreter','latex');
leg = legend('$u_1(n T_s)$','$u_2(n T_s)$');
set(leg,'Interpreter','latex','Location','best');