clear all; clc; close all;
fs=50; Ts=1/fs; s = tf('s');
G = 1/((s+2)*(s+5)*(s+7)); K_G = 1/dcgain(G); G = K_G*G;
%OBS 1: O ganho foi transferido para a matriz de entrada. Assim y = x_3
[A,B,C,D] = tf2ss(G.num{:},G.den{:}); B = B*K_G; C = C/K_G;
[Phi,Gamma] =  c2d(A,B,Ts);
Psi = [1 0 0]'; Rv = 1e-2; Rw = 1e-2; 
%OBS 2: no bloco State-Space1 a matriz B foi modificada para considerar a
%entrada de rudo em x_1. Consequentemente, D foi modificada
A1 = A; B1 = [B, Psi]; C1 = C; D1 = [0 0]; % Matrizes do bloco State-Space1
%OBS 3: no bloco State-Space2 foi feito C=eye(3) para obter todos os estados
% para fins de comparao
A2 = A; B2 = B; C2 = eye(3); D2 = [0; 0; 0]; % Matrizes do bloco State-Space2
x_0 = [1 0 1]; %estado inicial
item = 'a'; % Escolher 'a', 'b' ou 'c'
switch(item)
    case 'a' %Obs por valor atual
        so = [-21; -22+j*2; -22-j*2]; p_o = exp(so*Ts);
        Lc = place(Phi', (C*Phi)',p_o)';
        sim('SIM_Ex_09_03_a');
    case 'b' %Filtro de Kalman
        M_0 = eye(3); 
        sim('SIM_Ex_09_03_b');
    case 'c' %Filtro de Kalman estacionrio
        Lc = dlqe(Phi, Psi, C, Rw, Rv);
        sim('SIM_Ex_09_03_a');
    otherwise
        error('item precisa se ''a'', ''b'' ou ''c'' ');
end
x_1 = x_out(:,1); x_2 = x_out(:,2); x_3 = x_out(:,3); y = x_3;
x_chap_1 = x_chap_out(:,1); x_chap_2 = x_chap_out(:,2);
x_chap_3 = x_chap_out(:,3);  y_chap = x_chap_3;
t_d = (0:length(y_chap)-1)*Ts;
figure(1);
plot(t,y,'b',t_d,y_noisy,'y',t_d,y_chap,'r');
xlabel('$t$','Interpreter','latex'); 
ylabel('Amplitude','Interpreter','latex');
l = legend('$y$ sem ru\''ido','$y$ com ru\''ido', '$\hat y$'); 
set(l,'Interpreter','Latex','Fontsize',12);
set(findall(gcf,'type','line'),'linewidth',1.0); 

figure(2);
subplot(3,1,1);plot(t,x_1,'b--',t_d,x_chap_1,'r'); axis([0 20 -4 4]);
xlabel('$t$','Interpreter','latex'); 
ylabel('Amplitude','Interpreter','latex');
l = legend('$x_1$','$\hat x_1$'); set(l,'Interpreter','Latex','Fontsize',12);
subplot(3,1,2);plot(t,x_2,'b--',t_d,x_chap_2,'r'); axis([0 20 -2 2]);
xlabel('$t$','Interpreter','latex'); 
ylabel('Amplitude','Interpreter','latex');
l = legend('$x_2$','$\hat x_2$'); set(l,'Interpreter','Latex','Fontsize',12);
subplot(3,1,3);plot(t,x_3,'b--',t_d,x_chap_3,'r'); axis([0 20 -0.5 1.5]);
xlabel('$t$','Interpreter','latex'); 
ylabel('Amplitude','Interpreter','latex');
l = legend('$x_3$','$\hat x_3$'); set(l,'Interpreter','Latex','Fontsize',12);
set(findall(gcf,'type','line'),'linewidth',1.0);